'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * 省市区级联选择
 */
var React = require('react');
var city = require('./area-cn/CityJson');
var DistrictJson = require('./area-cn/DistrictJson');
var YYCascader = require('../../yylib2/formcontrols/cascader/YYCascader');
var province = require('./area-cn/ProJson');

var YYAreaCascader = React.createClass({
    displayName: 'YYAreaCascader',

    getDefaultProps: function getDefaultProps() {
        return {
            placeholder: '请选择地点'
        };
    },
    _getJsonData: function _getJsonData() {
        var opthon = [];
        for (var i = 0; i < province.length; i++) {
            var citychildren = [];
            for (var j = 0; j < city.length; j++) {
                var dischildren = [];
                if (city[j].ProID == province[i].ProID) {
                    for (var k = 0; k < DistrictJson.length; k++) {
                        if (city[j].CityID == DistrictJson[k].CityID) {
                            var disjson = {
                                value: DistrictJson[k].Id,
                                label: DistrictJson[k].DisName
                            };
                            dischildren.push(disjson);
                        }
                    }
                    var cityJson = {
                        value: city[j].CityID,
                        label: city[j].CityName,
                        children: dischildren
                    };
                    citychildren.push(cityJson);
                }
            }
            var proJSON = {
                value: province[i].ProID,
                label: province[i].ProName,
                children: citychildren
            };
            opthon.push(proJSON);
        }
        return opthon;
    },
    render: function render() {
        return React.createElement(YYCascader, _extends({}, this.props, { options: this._getJsonData(), placeholder: this.props.placeholder }));
    }
});
module.exports = YYAreaCascader;