'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Created by Administrator on 2016/7/26.
 */
var React = require('react');

var _require = require('yylib-ui'),
    YYButton = _require.YYButton,
    YYTable = _require.YYTable,
    YYUpload = _require.YYUpload,
    YYClass = _require.YYClass,
    YYTooltip = _require.YYTooltip,
    YYToolbar = _require.YYToolbar,
    YYMessage = _require.YYMessage,
    YYPopconfirm = _require.YYPopconfirm,
    YYIcon = _require.YYIcon,
    YYModal = _require.YYModal;

require("../upload.css");

var _require2 = require("../attachaction"),
    loadAttachList = _require2.loadAttachList,
    delAttach = _require2.delAttach,
    showErrMsg = _require2.showErrMsg,
    downloadUrl = _require2.downloadUrl,
    listUrl = _require2.listUrl,
    uploadUrl = _require2.uploadUrl,
    delUrl = _require2.delUrl,
    handleUrl = _require2.handleUrl,
    formatDate = _require2.formatDate,
    getParamValue = _require2.getParamValue,
    loadFileListByFileIds = _require2.loadFileListByFileIds,
    getFileListByFileIdsUrl = _require2.getFileListByFileIdsUrl;

var AuthToken = require("yylib-utils/AuthToken");

var _require3 = require('yylib-utils/MathUtil'),
    execute = _require3.execute;

var _ = require('lodash');
//下载url
//const downloadUrl = "/icop-file/file/download?id=";
//获取附件列表的url
//const listUrl = "/icop-file/file/list";
//上传url
//const uploadUrl = "/icop-file/file/upload2";

//const delUrl = "/icop-file/file/del";

//参数object&操作方法
//var dataMap = {};

var AttachMgrTable = YYClass.create({
    getDefaultProps: function getDefaultProps() {
        return { showUploadBtn: true, showDelBtn: true, readOnly: false, beforeUpload: null, beforeDel: null,
            userId: '', userName: '', enableUser: true, deleteTip: '删除的附件不可恢复！确定要删除？' };
    },
    getInitialState: function getInitialState() {
        var enableUser = false;
        if (this.props.enableUser != false) {
            enableUser = true;
        }
        var userId = this.props.userId;
        var userName = this.props.userName;
        if (enableUser) {
            if (!userId) {
                userId = AuthToken.getUserId();
            }
            if (!userName) {
                userName = AuthToken.getUserName();
            }
        }
        return {
            serverUrl: '',
            selectId: [],
            current: 1,
            sourceId: null,
            defaultValue: null,
            billType: null,
            sourceType: null,
            pageVisible: false,
            totalsize: 0,
            data: [],
            pageInfo: {
                pageNumber: 1,
                pageSize: 10
            },
            isload: false,
            dataMap: {},
            selectItems: [],
            //上传进度
            //uploadEvent:null,
            fileList: [],
            userId: userId,
            userName: userName
            // previewVisible: false,//图片预览窗口
            // previewImage: ''//图片预览url
        };
    },

    _loadList: function _loadList(serverUrl, billType, sourceId, sourceType) {
        var url = serverUrl + listUrl;
        var that = this;
        loadAttachList(url, { id: sourceId, billType: billType, type: sourceType }, function (data) {
            that.setState({ data: data });
            that.state.dataMap[sourceType] = data;
        }, function (msg) {
            showErrMsg("上传失败", msg);
        });
    },
    _removeFile: function _removeFile(serverUrl, sourceId, billType, sourceType, ids) {
        var url = serverUrl + delUrl;
        var that = this;
        if (sourceId && billType) {
            delAttach(url, { id: sourceId, billType: billType, sourceType: sourceType, attachIds: ids }, function (data) {
                if (data.success) {
                    that.doRemove(sourceType, ids);
                } else {
                    showErrMsg("删除失败", data.backMsg);
                }
            }, function (msg) {
                showErrMsg("删除失败", msg);
            });
        } else {
            that.doRemove(sourceType, ids);
        }
    },
    doRemove: function doRemove(sourceType, idArr) {
        var newFileArr = [];
        var files = this.state.data;
        var that = this;
        files.map(function (item, i) {
            if (!that.arrayContains(idArr, item.gid)) {
                newFileArr.push(item);
            }
        });
        this.setState({ data: newFileArr, selectId: [], selectItems: [] });
        this.state.dataMap[sourceType] = newFileArr; //将更新的数据放入map中
        this.onChangePage(1);

        this.refreshValue();
    },
    arrayContains: function arrayContains(arr, obj) {
        var i = arr.length;
        while (i--) {
            if (arr[i] === obj) {
                return true;
            }
        }
        return false;
    },
    //查询数据
    componentDidMount: function componentDidMount() {
        //进入编辑页面第一次时需要调用该方法加载
        var defaultValue = this.props.defaultValue;
        var sourceId = this.props.sourceId;
        var billType = this.props.billType;
        var sourceType = this.props.sourceType;
        this.setState({ sourceId: sourceId, defaultValue: defaultValue });

        if (defaultValue) {
            this._loadDefaultList(this.props.serverUrl, defaultValue, sourceType);
        } else if (sourceId && billType) {
            this.setState({ data: [], dataMap: {} });
            this._loadList(this.props.serverUrl, billType, sourceId, sourceType);
        }
        /*var sourceId =this.props.sourceId;
        var billType=this.props.billType;
        var sourceType = this.props.sourceType;
        //this.setState({dataMap:[]});
        var lastSourceId = this.state.sourceId;
        if(!sourceId){
            sourceId="";
        }
        if(!lastSourceId){
            lastSourceId = "";
        }
        this.setState({sourceId:sourceId});
        if(sourceId && billType){
            this.setState({isload:true});
            if(sourceId!=lastSourceId){////sourceId变化时才加载附件列表
                this.setState({data:[],dataMap:{}});//sourceId有变化，该值已无意义
                this._loadList(this.props.serverUrl,billType,sourceId,sourceType);
            }
        }else{
            if(sourceId==lastSourceId){ //sourceId发生变化就应该清空列表
                var data = [];
                if(sourceType in this.state.dataMap) {
                    data = this.state.dataMap[sourceType];
                }
                this.setState({data: data});
            }else{
                this.setState({data:[],dataMap:{}});
            }
        }*/
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        /* if(this.state.isload){
             return;
         }*/
        var defaultValue = nextProps.defaultValue;
        var sourceId = nextProps.sourceId;
        var billType = nextProps.billType;
        var sourceType = nextProps.sourceType;
        //this.setState({dataMap:[]});
        var lastSourceId = this.state.sourceId;
        var lastSourceType = this.state.sourceType;

        if (!sourceId) {
            sourceId = "";
        }
        if (!lastSourceId) {
            lastSourceId = "";
        }
        if (!billType) {
            billType = "";
        }
        if (!lastSourceType) {
            lastSourceType = "";
        }
        this.setState({ sourceId: sourceId, sourceType: sourceType });
        if (defaultValue && defaultValue !== this.state.defaultValue) {
            this._loadDefaultList(this.props.serverUrl, defaultValue, sourceType);
            this.setState({ defaultValue: defaultValue });
        } else if (sourceId && billType) {
            this.setState({ isload: true });
            if (sourceId != lastSourceId) {
                ////sourceId变化时才加载附件列表
                this.setState({ data: [], dataMap: {} }); //sourceId有变化，该值已无意义
                this._loadList(this.props.serverUrl, billType, sourceId, sourceType);
            } else {
                if (sourceType != lastSourceType) {
                    //文件类型变化了，重新加载
                    this.setState({ data: [] }); //sourceId有变化，该值已无意义
                    this._loadList(this.props.serverUrl, billType, sourceId, sourceType);
                }
            }
        } else {
            if (sourceId == lastSourceId) {
                //sourceId发生变化就应该清空列表
                if (sourceType != lastSourceType) {
                    //文件类型变化了，重新加载
                    var data = [];
                    if (sourceType in this.state.dataMap) {
                        data = this.state.dataMap[sourceType];
                    }
                    this.setState({ data: data });
                }
            } else {
                this.setState({ data: [], dataMap: {} });
            }
        }
    },
    _loadDefaultList: function _loadDefaultList(serverUrl, defaultValue, sourceType) {
        var url = serverUrl + getFileListByFileIdsUrl;
        var that = this;
        loadFileListByFileIds(url, { ids: defaultValue }, function (data) {
            if (data.success) {
                var fileData = data.backData || [];
                that.state.data = fileData;
                that.state.dataMap[sourceType] = fileData;
                that.setState(that.state, function () {
                    var map = {};
                    var ids = [];
                    fileData.map(function (item) {
                        ids.push(item.gid);
                    });
                    map[sourceType] = ids.join(",");
                    that.props.modal.changeValue(JSON.stringify(map), ids.length);
                });
            }
        });
    },

    //显示条数
    showTotal: function showTotal(total) {
        return '\u5171 ' + total + ' \u6761';
    },
    //改变页码
    onChangePage: function onChangePage(page) {
        var pageInfo = {
            pageNumber: page - 1,
            pageSize: this.state.pageInfo.pageSize
        };
        this.setState({
            pageInfo: pageInfo
        }, function () {});
    },
    //批量删除
    deleteAll: function deleteAll(e) {
        var ids = this.state.selectId;
        if (ids && ids.length > 0) {
            //删除前判断
            if (this.props.beforeDel) {
                if (!this.props.beforeDel(this.state.selectItems)) {
                    return false;
                }
            }
            this._removeFile(this.props.serverUrl, this.props.sourceId, this.props.billType, this.props.sourceType, ids);
        } else {
            YYMessage.warn("请选择要删除的文件");
        }
    },
    // 批量下载
    downloadAll: function downloadAll(e) {
        var _this = this;

        var ids = this.state.selectId;
        if (ids && ids.length > 0) {
            var list = this.state.data ? this.state.data : [];
            //存放多个下载的文件信息
            var files = [];
            ids.forEach(function (id) {
                var record = list.filter(function (item) {
                    return item.gid === id;
                })[0];
                if (record) {
                    var urlName = handleUrl(_this.staticUrl() + "/" + record.filePath + "?filename=" + record.fileName);
                    record.downloadUrl = urlName; //生成下载文件的URL
                    files.push(record);
                }
            });
            files.forEach(function (file, index) {
                //动态添加iframe，设置src，然后删除 (依赖了jquery，需要解耦)
                setTimeout(function () {
                    var frame = document.createElement('iframe');
                    frame.src = file.downloadUrl;
                    frame.style.width = 0; //防止影响页面
                    frame.style.height = 0; //防止影响页面
                    frame.style = "display: none;";
                    document.body.appendChild(frame);
                    setTimeout(function () {
                        document.body.removeChild(frame);
                    }, 30000); //延长至30s后删除，防止有时请求还没得到响应就删除了，导致无法正常下载。
                }, index * 250); //防止连续下载被浏览器策略拦截的问题
            });
        } else {
            YYMessage.warn("请选择要下载的文件");
        }
    },
    // 预览
    _openPreview: function _openPreview(record) {
        // 获取文件后缀名
        var suffix = record.fileName.split(".").pop().toLowerCase();
        var isChrome = this.browserClass();
        var previewUrl = "";
        if (['pdf', 'PDF'].indexOf(suffix) > -1 && isChrome === "Chrome") {
            previewUrl = this.staticUrl() + "/" + record.filePath;
        } else {
            previewUrl = handleUrl(this.staticUrl() + "/icop-file/onlinePreview?url=" + this.staticUrl() + "/" + record.filePath + "?filename=" + record.fileName);
        };
        var previewWin = window.open(previewUrl);
        if (!previewWin) {
            YYMessage.error("预览窗口打开失败，请检查浏览器是否阻止弹出窗口！");
        };
    },
    browserClass: function browserClass() {
        var userAgent = navigator.userAgent;
        var isOpera = userAgent.indexOf("Opera") > -1;
        var isIE = userAgent.indexOf("compatible") > -1 && userAgent.indexOf("MSIE") > -1 && !isOpera;
        var isEdge = userAgent.indexOf("Edge") > -1;
        var isFF = userAgent.indexOf("Firefox") > -1;
        var isSafari = userAgent.indexOf("Safari") > -1 && userAgent.indexOf("Chrome") == -1;
        var isChrome = userAgent.indexOf("Chrome") > -1 && userAgent.indexOf("Safari") > -1;

        if (isIE) {
            var reIE = new RegExp("MSIE (\\d+\\.\\d+);");
            reIE.test(userAgent);
            var fIEVersion = parseFloat(RegExp["$1"]);
            if (fIEVersion == 7) {
                return "IE7";
            } else if (fIEVersion == 8) {
                return "IE8";
            } else if (fIEVersion == 9) {
                return "IE9";
            } else if (fIEVersion == 10) {
                return "IE10";
            } else if (fIEVersion == 11) {
                return "IE11";
            } else {
                return "0";
            } //IE版本过低
            return "IE";
        }
        if (isOpera) {
            return "Opera";
        }
        if (isEdge) {
            return "Edge";
        }
        if (isFF) {
            return "FF";
        }
        if (isSafari) {
            return "Safari";
        }
        if (isChrome) {
            return "Chrome";
        }
    },
    // handleCancelPreviewModal:function(){
    //     this.setState({ previewVisible: false, previewImage: '' })
    // },
    onUpload: function onUpload(e) {
        e.preventDefault();
    },
    refreshValue: function refreshValue() {
        // if(this.props.sourceId){
        //     this.props.modal.changeValue(null);
        //     return;
        // }
        var fileLength = 0;
        var map = {};
        for (var prop in this.state.dataMap) {
            if (this.state.dataMap.hasOwnProperty(prop)) {
                var arr = this.state.dataMap[prop];
                var newIdArr = [];
                _.map(arr, function (item, i) {
                    newIdArr.push(item.gid);
                });
                //文件个数
                fileLength = fileLength + newIdArr.length;
                map[prop] = newIdArr.join(',');
            }
        }
        /*var idArr = [];
        this.state.data.map(function(item,i){
            idArr.push(item.gid);
        })
        this.props.modal.changeValue(idArr.join(','));*/

        this.props.modal.changeValue(JSON.stringify(map), fileLength);
    },
    staticUrl: function staticUrl() {
        if (this.props.fileUrl) {
            return this.props.fileUrl;
        }
        return this.props.serverUrl;
    },
    timestampToDate: function timestampToDate(ts) {
        return new Date(parseInt(ts)).toLocaleString().replace(/:\d{1,2}$/, ' ');
    },
    render: function render() {
        var that = this;
        var totalsize = 0;
        var data = this.state.data ? this.state.data : [];
        var sourceId = this.props.sourceId;
        var billType = this.props.billType;
        var sourceType = this.props.sourceType;
        var visible = this.props.pageVisible;
        var uploadFileUrl = this.props.serverUrl + uploadUrl;
        var downloadFileUrl = this.props.serverUrl + downloadUrl;
        var staticUrl = this.staticUrl();
        var multiple = this.props.multiple;
        //console.log("sourceId:"+sourceId+",billType:"+billType+",sourceType:"+sourceType);
        //附件上传
        var defaultAccept = ".ppt,.pptx,.doc,.docx,.xls,.xlsx,.txt,.zip,.rar,.png,.jpg,.jpeg,.pdf,.PDF";
        var uploadProps = {
            accept: this.props.accept || defaultAccept,
            action: uploadFileUrl,
            multiple: multiple,
            showUploadList: true,
            data: { sourceId: getParamValue(sourceId), billType: billType, sourceType: sourceType, userId: that.state.userId, userName: that.state.userName },
            beforeUpload: function beforeUpload(info) {
                if (info.size == 0) {
                    showErrMsg('上传失败', '请不要上传空文件');
                    return false;
                }
                //上传前判断
                if (that.props.beforeUpload) {
                    if (!that.props.beforeUpload()) {
                        return false;
                    }
                }
                that.state.loadingDisplay = true;
                that.setState({ changeFlag: !that.state.changeFlag });
            },
            onChange: function onChange(info) {
                var files = info.fileList;
                if (info.file.status === 'done') {
                    var resultObj = info.file.response;
                    if (resultObj.success) {
                        var result = that.state.data || [];
                        if (result && !_.isEmpty(resultObj.backData)) {
                            result = result.concat(resultObj.backData);
                        }
                        that.setState({ data: result });
                        that.state.dataMap[sourceType] = result;
                        that.onChangePage(1);

                        that.refreshValue();
                    } else {
                        showErrMsg('上传失败', info.file.response.msg);
                    }
                    that.state.loadingDisplay = false;
                    that.setState({ changeFlag: !that.state.changeFlag });
                    that.setState({ uploadEvent: null, fileList: [] });
                } else if (info.file.status === 'error') {
                    showErrMsg('上传失败', '请求失败');
                    that.state.loadingDisplay = false;
                    that.setState({ changeFlag: !that.state.changeFlag });
                    that.setState({ uploadEvent: null, fileList: [] });
                }
                that.setState({ uploadEvent: info.event, fileList: files });
            }
        };
        var pagination = {
            total: data.length,
            showSizeChanger: true,
            onShowSizeChange: function onShowSizeChange(current, pageSize) {}
        };
        // var { previewVisible, previewImage } = this.state;
        var columns = [{
            title: '文件名',
            dataIndex: 'fileName',
            key: 'fileName',
            width: 240
        }, {
            title: '操作',
            dataIndex: 'preview',
            width: 90,
            key: 'preview',
            render: function render(text, record, index) {
                if (record.gid) {
                    var urlName = handleUrl(staticUrl + "/" + record.filePath + "?filename=" + record.fileName);
                    return React.createElement(
                        'span',
                        null,
                        React.createElement(
                            'a',
                            { onClick: function onClick() {
                                    return that._openPreview(record);
                                }, style: { marginRight: 10 } },
                            '\u9884\u89C8'
                        ),
                        React.createElement(
                            'a',
                            { target: '_blank', href: urlName },
                            '\u4E0B\u8F7D'
                        )
                    );
                }
                return "";
            }
        }, {
            title: '上传人',
            width: 80,
            dataIndex: 'createName',
            key: 'createName'
        }, {
            title: '类型',
            dataIndex: 'docType',
            width: 80,
            key: 'docType',
            render: function render(text, record, index) {
                if (record.fileName) {
                    var fileName = record.fileName;
                    var idx = fileName.lastIndexOf('.');
                    if (idx > -1) {
                        return fileName.substr(idx + 1);
                    }
                }
                return "";
            }
        }, {
            title: '大小(KB)',
            isShow: true,
            width: 80,
            dataIndex: 'fileSize',
            key: 'fileSize',
            render: function render(text, record, index) {
                if (record.fileSize) {
                    return execute(record.fileSize, 1024, 3, 1);
                }
                return "";
            }
        }, {
            title: '上传时间',
            isShow: true,
            dataIndex: 'createDate',
            width: 80,
            key: 'createDate',
            render: function render(text, record, index) {
                if (record.createDate) {
                    return formatDate(new Date(parseInt(record.createDate)), "yyyy-MM-dd");
                }
                return "";
            }
        }];
        var rowSelection = {
            onChange: function onChange(selectedRowKeys, selectedRows) {
                that.setState({ selectId: selectedRowKeys });
                that.setState({ selectItems: selectedRows });
            },
            onSelect: function onSelect(record, selected, selectedRows) {},
            onSelectAll: function onSelectAll(selected, selectedRows, changeRows) {},

            selectedRowKeys: this.state.selectId
        };

        // var showUploadArea = this.props.showUploadBtn || this.props.showDelBtn;
        var showUpload = this.props.showUploadBtn;
        var showDel = this.props.showDelBtn;
        var readOnly = this.props.readOnly;
        // var uploadProgress = this.state.uploadEvent;
        var fileList = this.state.fileList;
        return React.createElement(
            'div',
            { className: 'attachment-page' },
            React.createElement(
                YYToolbar,
                { className: 'attachment-toolbar' },
                showUpload && !readOnly ? React.createElement(
                    YYUpload,
                    _extends({}, uploadProps, { fileList: fileList }),
                    this.props.accept ? React.createElement(
                        YYTooltip,
                        { placement: 'top', title: '文件格式：' + this.props.accept },
                        React.createElement(
                            YYButton,
                            { onClick: that.onUpload },
                            '\u4E0A\u4F20\u9644\u4EF6'
                        )
                    ) : React.createElement(
                        YYButton,
                        { onClick: that.onUpload },
                        '\u4E0A\u4F20\u9644\u4EF6'
                    )
                ) : null,
                showDel && !readOnly ? React.createElement(
                    YYPopconfirm,
                    { onConfirm: this.deleteAll, title: this.props.deleteTip },
                    React.createElement(
                        YYButton,
                        { disabled: !(this.state.selectId && this.state.selectId.length > 0) },
                        '\u6279\u91CF\u5220\u9664'
                    )
                ) : null,
                React.createElement(
                    YYButton,
                    { onClick: this.downloadAll, disabled: !(this.state.selectId && this.state.selectId.length > 0) },
                    '\u6279\u91CF\u4E0B\u8F7D'
                )
            ),
            React.createElement(
                'div',
                { className: 'attachmentmgr' },
                React.createElement(YYTable, { rowKey: function rowKey(record) {
                        return record.gid;
                    }, bordered: true, showRowNum: true, dataSource: data, pagination: pagination,
                    columns: columns, rowSelection: rowSelection })
            )
        );
    }
});
module.exports = AttachMgrTable;