'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _yylibUi = require('yylib-ui');

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;


function noop() {}

var uiMeta = {
    name: 'ijz-toolbar',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-toolbar', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('enableAffix', true, PropTypes.bool, false, '是否启用固定'), field('bigTitle', '', PropTypes.string, false, '大标题'), field('children', [], PropTypes.array, false, '按钮属性配置'), field('viewMode', 'card', PropTypes.string, PropTypes.oneOf(['card', 'table']), '大标题'), field('goBackBtnVisible', false, PropTypes.bool, false, '返回按钮的是否显示'), field('reloadBtnVisible', true, PropTypes.bool, false, '刷新按钮是否显示'), field('onItemButtonClick', noop, PropTypes.func, false, '右侧按钮项回调，(key, item)=>{}')]
};

var IjzToolBar = _yylibUi.YYClass.create({
    uiMeta: uiMeta,

    getInitialState: function getInitialState() {
        return {
            expand: false,
            isShowExpand: false,
            someContent: [],
            totalContent: []
        };
    },
    componentDidMount: function componentDidMount() {
        this.renderButtons(this.props.children);
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if ("children" in nextProps && nextProps.children !== this.props.children) {
            this.renderButtons(nextProps.children);
            this.setState({
                expand: false
            });
        }
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    onItemButtonClick: function onItemButtonClick(uikey, item, self) {
        var onItemButtonClick = this.props.onItemButtonClick;

        if (item && item.type.displayName === "YYButtonSelect") {
            onItemButtonClick(self, item);
            if (item && item.props && item.props.onClick) {
                item.props.onClick(self, item);
            }
        } else {
            onItemButtonClick(uikey, item);
            if (item && item.props && item.props.onClick) {
                item.props.onClick(uikey, item);
            }
        }
    },

    _createSpan: function _createSpan() {
        return _react2.default.createElement(
            'div',
            { className: this.className('toolBar-collapse') },
            _react2.default.createElement(
                'span',
                { onClick: this._onChange },
                this.state.expand ? '收回' : '展开'
            ),
            _react2.default.createElement(_antd.Icon, {
                type: this.state.expand ? "up" : "down",
                classnames: this.className('collapse-icon'),
                onClick: this._onChange
            })
        );
    },
    _onChange: function _onChange() {
        var _state = this.state,
            expand = _state.expand,
            totalContent = _state.totalContent;

        this.setState({
            expand: !expand,
            someContent: expand ? totalContent.slice(0, 8) : totalContent
        });
    },
    renderButtons: function renderButtons() {
        var _this = this;

        var children = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

        // const {children, reloadBtnVisible} = this.props;
        var content = [];
        _react2.default.Children.map(children, function (item, index) {
            content.push(_react2.default.cloneElement(item, { onClick: _this.onItemButtonClick.bind(null, item.props.uikey, item) }));
        });
        if (content.length > 8) {
            this.setState({
                isShowExpand: true,
                someContent: content.slice(0, 8),
                totalContent: content
            });
        } else {
            this.setState({
                isShowExpand: false,
                someContent: content,
                totalContent: content
            });
        }
        // return content;
    },
    render: function render() {
        var _props = this.props,
            bigTitle = _props.bigTitle,
            enableAffix = _props.enableAffix,
            viewMode = _props.viewMode,
            goBackBtnVisible = _props.goBackBtnVisible,
            reloadBtnVisible = _props.reloadBtnVisible,
            helpComponent = _props.helpComponent,
            otherProps = _objectWithoutProperties(_props, ['bigTitle', 'enableAffix', 'viewMode', 'goBackBtnVisible', 'reloadBtnVisible', 'helpComponent']);

        var _state2 = this.state,
            someContent = _state2.someContent,
            totalContent = _state2.totalContent,
            isShowExpand = _state2.isShowExpand,
            expand = _state2.expand;

        var span = this._createSpan();
        return _react2.default.createElement(
            _yylibUi.YYToolbar,
            { className: (0, _classnames2.default)(this.getClassName(), viewMode), enableAffix: enableAffix },
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-left' },
                _react2.default.createElement(_yylibUi.YYButton, { type: 'ghost', icon: 'left', ref: 'ijz_toolbar_left', visible: goBackBtnVisible,
                    onClick: this.onItemButtonClick.bind(null, 'ijz_toolbar_left', undefined)
                }),
                bigTitle,
                helpComponent
            ),
            _react2.default.createElement(
                'div',
                { className: this.getClassName() + '-right' },
                _react2.default.createElement(
                    _antd.Row,
                    { type: 'flex' },
                    _react2.default.createElement(
                        _antd.Col,
                        {
                            span: expand || !isShowExpand ? 24 : 22,
                            className: this.getClassName() + '-right-buttons'
                        },
                        someContent,
                        _react2.default.createElement(_yylibUi.YYButton, { type: 'ghost', ref: 'ijz_toolbar_reload', visible: reloadBtnVisible,
                            onClick: this.onItemButtonClick.bind(null, 'ijz_toolbar_reload', undefined),
                            icon: 'reload' }),
                        expand && isShowExpand && span
                    ),
                    !expand && isShowExpand && _react2.default.createElement(
                        _antd.Col,
                        {
                            span: 2, className: this.getClassName() + '-right-expand'
                        },
                        isShowExpand ? span : null
                    )
                )
            )
        );
    }
});

module.exports = IjzToolBar;