'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 下拉菜单组件按钮组件
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var YYMenu = require('../menu/YYMenu');

var _require = require('react-dom'),
    findDOMNode = _require.findDOMNode;

var _ = require('lodash');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require2 = require('antd'),
    Dropdown = _require2.Dropdown,
    Menu = _require2.Menu,
    Icon = _require2.Icon,
    Button = _require2.Button;

var DropdownButton = Dropdown.Button;
var ButtonGroup = Button.Group;
require('./style/index.less');
var menu = React.createElement(YYMenu, null);

var classNames = require('classnames');

function splitObject(obj, parts) {
    var left = {};
    var right = {};
    Object.keys(obj).forEach(function (k) {
        if (parts.indexOf(k) !== -1) {
            left[k] = obj[k];
        } else {
            right[k] = obj[k];
        }
    });
    return [left, right];
}
//重写antd的实现，以支持ghost属性的实现 by zhuzj
DropdownButton.prototype.render = function () {
    var _splitObject = splitObject(this.props, ['type', 'ghost', 'overlay', 'trigger', 'align', 'children', 'className', 'onClick']),
        _splitObject2 = _slicedToArray(_splitObject, 2),
        _splitObject2$ = _splitObject2[0],
        type = _splitObject2$.type,
        ghost = _splitObject2$.ghost,
        overlay = _splitObject2$.overlay,
        trigger = _splitObject2$.trigger,
        align = _splitObject2$.align,
        children = _splitObject2$.children,
        className = _splitObject2$.className,
        onClick = _splitObject2$.onClick,
        restProps = _splitObject2[1];

    var cls = classNames(_defineProperty({
        'ant-dropdown-button': true
    }, className, !!className));
    var btnCls = classNames({
        'ghost': ghost
    });
    return React.createElement(
        ButtonGroup,
        _extends({}, restProps, { className: cls }),
        React.createElement(
            Button,
            { type: type, className: btnCls, onClick: onClick },
            children
        ),
        React.createElement(
            Dropdown,
            { align: align, overlay: overlay, trigger: trigger },
            React.createElement(
                Button,
                { type: type, className: btnCls },
                React.createElement(Icon, { type: 'down' })
            )
        )
    );
};
//定义META
var uiMeta = {
    name: 'dropdownbutton',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('type', '', PropTypes.oneOf(['primary', 'success', 'info', 'warning', 'error', '']), false, '设置按钮类型，可选值为 primary|success|info|warning|error 或者不设'), field('ghost', false, PropTypes.bool, false, '设置按钮为不填充形态'), field('onClick', null, PropTypes.func, false, '点击左侧按钮的回调'), field('trigger', 'hover', PropTypes.oneOf(['click', 'hover']), false, '触发下拉的行为'), field('overlay', null, PropTypes.instanceOf(Menu), false, '菜单'), field('visible', null, PropTypes.bool, false, '菜单是否显示'), field('onVisibleChange', null, PropTypes.func, false, '菜单显示状态改变时调用，参数为 { visible }'), field('disabled', false, PropTypes.bool, false, '组件是否被禁用')]
};
var YYDropdownButton = YYClass.create({
    uiMeta: uiMeta,
    getInitialState: function getInitialState() {
        var _props = this.props,
            overlay = _props.overlay,
            disabled = _props.disabled;

        return {
            overlay: disabled ? menu : overlay,
            disabled: disabled
        };
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if ('disabled' in nextProps) {
            var disabled = nextProps.disabled;
            var overlay = disabled ? menu : nextProps.overlay ? nextProps.overlay : menu;
            this.setState({
                disabled: disabled,
                overlay: overlay
            });
        }
    },
    _handleAttr: function _handleAttr(doms, value) {
        _.forEach(doms, function (dom) {
            if (value === true) {
                dom.setAttribute('disabled', value);
            } else {
                dom.removeAttribute("disabled");
            }
        });
    },
    componentDidMount: function componentDidMount() {
        var disabled = this.state.disabled;
        var buttonDom = findDOMNode(this).getElementsByTagName('button');
        if (disabled == true) {
            this._handleAttr(buttonDom, true);
        }
    },
    componentDidUpdate: function componentDidUpdate(prevProps, prevState) {
        var disabled = this.state.disabled;
        var buttonDom = findDOMNode(this).getElementsByTagName('button');
        if (disabled) {
            this._handleAttr(buttonDom, true);
        } else {
            this._handleAttr(buttonDom, false);
        }
    },
    render: function render() {
        var _state = this.state,
            disabled = _state.disabled,
            overlay = _state.overlay;

        var cls = disabled ? 'disabled' : '';
        return React.createElement(
            DropdownButton,
            _extends({}, this.props, {
                disabled: disabled,
                overlay: overlay,
                className: '' + (this.className() + ' ' + cls)
            }),
            this.props.children
        );
    }
});
module.exports = YYDropdownButton;