'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * 模态对话框
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;

var _require = require('antd'),
    Modal = _require.Modal;

var Draggable = require('react-draggable');
require('./style/index.less');
var meta = require('./meta');
//定义META
var uiMeta = meta;
var YYModal = YYClass.create({
    uiMeta: uiMeta,
    statics: {
        info: Modal.info,
        success: Modal.success,
        error: Modal.error,
        warning: Modal.warning,
        confirm: Modal.confirm
    },
    getInitialState: function getInitialState() {
        return {
            offsetLeft: null,
            offsetTop: null,
            mStyle: null,
            visible: this.props.visible
        };
    },
    componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
        if ('visible' in nextProps) {
            this.setState({ visible: nextProps.visible });
        }
    },
    handleCancel: function handleCancel(e) {
        if (typeof this.props.onCancel == 'function') {
            this.props.onCancel(e);
        } else {
            this.setState({ visible: false });
        }
    },
    handleOk: function handleOk(e) {
        if (typeof this.props.onOk == 'function') {
            this.props.onOk(e);
        } else {
            this.setState({ visible: false });
        }
    }
    //渲染可拖拽区域的头部
    , renderDraggableHeader: function renderDraggableHeader() {
        var _props = this.props,
            title = _props.title,
            draggable = _props.draggable;

        var that = this;
        //如果未启用拖拽则默认返回原始title
        if (!draggable) return title;
        //包装拖拽的头部区域
        var headerTitle = null;
        if (title) {
            //如果存在头部标题|元素则直接在此基础上包装
            if (React.isValidElement(title)) {
                headerTitle = title;
            } else {
                headerTitle = React.createElement(
                    'div',
                    null,
                    title
                );
            }
        } else {
            //如果不存在头部标题则构建一个空的头部作为可拖拽区域
            headerTitle = React.createElement(
                'div',
                { className: 'empty-draggable-area' },
                '\u70B9\u6B64\u5904\u62D6\u62FD\u79FB\u52A8'
            );
        }
        var rndDiv = React.createElement(
            Draggable,
            {
                position: { x: 0, y: 0 },
                onStart: function onStart(e, data) {
                    //获取到yyui-modal ant-modal层级的元素矩阵
                    var modalRect = e.currentTarget.parentNode.parentNode.parentNode.parentNode.getBoundingClientRect();
                    //获取当前点击位置距离弹窗左上角的位置
                    var offsetLeft = e.clientX - modalRect.left;
                    var offsetTop = e.clientY - modalRect.top;
                    //清除默认的margin，定位到当前原始位置
                    that.setState({ mStyle: { margin: 0, left: modalRect.left, top: modalRect.top }, offsetLeft: offsetLeft, offsetTop: offsetTop });
                },
                onDrag: function onDrag(e, data) {
                    //移动到对应拖拽时的位置
                    that.setState({ mStyle: { margin: 0, left: e.clientX - that.state.offsetLeft, top: e.clientY - that.state.offsetTop } });
                },
                onStop: function onStop(e, data) {
                    // that.setState({mStyle:{left:e.clientX,top:e.clientY}});
                }
            },
            headerTitle
        );
        return rndDiv;
    },
    render: function render() {
        var modalTitle = this.renderDraggableHeader();
        return React.createElement(
            Modal,
            _extends({}, this.props, { visible: this.state.visible, onOk: this.handleOk, onCancel: this.handleCancel, title: modalTitle, style: _.assign({}, this.props.style, this.state.mStyle), prefixCls: this.className() + ' ant-modal' }),
            this.props.children
        );
    }
});
module.exports = YYModal;