'use strict';

/**
 * Created by Dio on 2016/9/1.
 */
var React = require('react');
var YYClass = require('../base/YYClass');
var PropTypes = YYClass.PropTypes;
var field = YYClass.field;
var YYPage = require('../container/YYPage');
var DoublePage = require('./DoublePage');
var _ = require('lodash');
//定义META
var uiMeta = {
    name: 'template',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('layout', 'tb', PropTypes.string, true, '模板布局类型')]
    //已过期，不推荐使用。
};var YYTemplate = YYClass.create({
    uiMeta: uiMeta,
    getInitialState: function getInitialState() {
        return {};
    },
    _renderContent: function _renderContent() {
        var views = [];
        if (this.props.layout == "tb") {
            //单页上下布局
            if (this.props.toolbar) {
                views.push(this.props.toolbar);
            }
            if (this.props.table) {
                views.push(this.props.table);
            }
            if (this.props.cards) {
                views.push(this.props.cards);
            }
        } else if (this.props.layout == "lr") {
            //左右布局
            views.push(React.createElement(DoublePage, this.props));
        }
        if (this.props.children) {
            views.push(this.props.children);
        }
        return views;
    },
    render: function render() {
        var cls = this.className();
        var style = _.assign({ paddingTop: 0, paddingRight: 10, paddingLeft: 10, paddingBottom: 10 }, this.props.style);
        return React.createElement(
            YYPage,
            { className: cls, style: style },
            this._renderContent()
        );
    }
});
module.exports = YYTemplate;